#include <iostream>
#include <vector>
#include <thread>
#include <atomic>
#include <mutex>
#include <condition_variable>

#include "Barrier.hpp"

using namespace std;


void barrierWaiting(int numIterations, Barrier &barrier) {
    for (int i = 0; i < numIterations; i++) {
        barrier.wait();
    }
}

int main() {
    int numIterations = 20;
    int numWorkers = 10;
    Barrier barrier(numWorkers);

    vector<thread> workers;
    for (int workerIndex = 0; workerIndex < numWorkers; workerIndex++) {
        workers.emplace_back(barrierWaiting, numIterations, ref(barrier));
    }

    for (auto &worker : workers) {
        worker.join();
    }

    return 0;
}

