#include <chrono>
#include <iostream>
#include <thread>
#include <future>

using namespace std;
using namespace std::chrono;

void doJob(promise<int> &promise) {
    this_thread::sleep_for(chrono::seconds(2));
    promise.set_value(42);
}

int main() {
    promise<int> promise;
    future<int> future = promise.get_future();
    thread worker(doJob, ref(promise));
    cout << "Future value obtained in main thread: " << flush;
    cout << future.get() << endl;
    worker.join();
    return 0;
}
